/* ////////////////////////////////////////////////////////////

File Name: textresource.h
Copyright (c) 2015 Soji Yamakawa.  All rights reserved.
http://www.ysflight.com

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, 
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, 
   this list of conditions and the following disclaimer in the documentation 
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS 
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE 
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

//////////////////////////////////////////////////////////// */

#ifndef FSTEXTRESOURCE_IS_INCLUDED
#define FSTEXTRESOURCE_IS_INCLUDED
/* { */

#include <ysclass.h>



extern YsTextResource fsGuiTextResource;

inline const wchar_t *FsGetTextResource(const char *key,const wchar_t *alternative)
{
	const wchar_t *primary=fsGuiTextResource.FindWString(key);
	if(NULL!=primary)
	{
		return primary;
	}
	return alternative;
}


#define FSGUI_COMMON_CLEAR                                FsGetTextResource("common/clear",L"Clear")
#define FSGUI_COMMON_CUTPLANE                             FsGetTextResource("common/cutplane",L"Cutting Plane")
#define FSGUI_COMMON_DISTTHR                              FsGetTextResource("common/distthr",L"Distance Threshold")
#define FSGUI_COMMON_G0CONTINUOUS                         FsGetTextResource("common/g0continuous",L"G0 continuous")
#define FSGUI_COMMON_G1CONTINUOUS                         FsGetTextResource("common/g1continuous",L"G1 continuous")
#define FSGUI_COMMON_G2CONTINUOUS                         FsGetTextResource("common/g2continuous",L"G2 continuous")
#define FSGUI_COMMON_HELP                                 FsGetTextResource("common/help",L"Help")
#define FSGUI_COMMON_INSERT                               FsGetTextResource("common/insert",L"Insert")
#define FSGUI_COMMON_LENGTH                               FsGetTextResource("common/length",L"Length")
#define FSGUI_COMMON_NORMAL                               FsGetTextResource("common/normal",L"Normal")
#define FSGUI_COMMON_OK                                   FsGetTextResource("common/ok",L"OK")
#define FSGUI_COMMON_CANCEL                               FsGetTextResource("common/cancel",L"Cancel")
#define FSGUI_COMMON_CLOSE                                FsGetTextResource("common/close",L"Close")
#define FSGUI_COMMON_DELETE                               FsGetTextResource("common/delete",L"Delete")
#define FSGUI_COMMON_REVERSE                              FsGetTextResource("common/reverse",L"Reverse")
#define FSGUI_COMMON_TANGENT                              FsGetTextResource("common/tangent",L"Tangent")
#define FSGUI_COMMON_TYPE                                 FsGetTextResource("common/type",L"Type")
#define FSGUI_COMMON_YES                                  FsGetTextResource("common/yes",L"Yes")
#define FSGUI_COMMON_NO                                   FsGetTextResource("common/no",L"No")
#define FSGUI_COMMON_ERROR                                FsGetTextResource("common/error",L"Error!")
#define FSGUI_COMMON_ANGLE                                FsGetTextResource("common/angle",L"Angle")



#define FSGUI_DLG_ABOUT_DONATELINE1                       FsGetTextResource("dlg/about/donateline1",L"Polygon Crest is a free and open-source polygon editor.\nBut, I appreicate if you can donate some money for supporting the development.")
#define FSGUI_DLG_ABOUT_DONATELINE2                       FsGetTextResource("dlg/about/donateline2",L"If you don't mind making some donation, please send money\nvia PayPal from the following button.")
#define FSGUI_DLG_ABOUT_DONATELINE3                       FsGetTextResource("dlg/about/donateline3",L"...")
#define FSGUI_DLG_ABOUT_DONATEPAYPAL                      FsGetTextResource("dlg/about/donatepaypal",L"Donate via PayPal")
#define FSGUI_DLG_ABOUT_DONATEVECTOR                      FsGetTextResource("dlg/about/donatevector",L"Donate via Vector ShareReg")
#define FSGUI_DLG_AIRFOIL_CREATE                          FsGetTextResource("dlg/airfoil/create",L"Create")
#define FSGUI_DLG_AIRFOIL_NACA4_MATCHTAIL                 FsGetTextResource("dlg/airfoil/naca4/matchtail",L"Match Tail")
#define FSGUI_DLG_AIRFOIL_NACA6_MODIFIEDMEANLINE          FsGetTextResource("dlg/airfoil/naca6/modifiedmeanline",L"Modified Mean Line")
#define FSGUI_DLG_AIRFOIL_SUPERCRITICAL_MATCHTAIL         FsGetTextResource("dlg/airfoil/supercritical/matchtail",L"Match Tail")
#define FSGUI_DLG_BOOL_CLICKONSHELL                       FsGetTextResource("dlg/bool/clickonshell",L"Click on the model that the boolean operation is calculated with the current model.")
#define FSGUI_DLG_BOOL_CURRENTSHELL                       FsGetTextResource("dlg/bool/currentshell",L"[Current model]")
#define FSGUI_DLG_BOOL_DEFECTEXPLANATION                  FsGetTextResource("dlg/bool/defectexplanation",L"Models need to be closed solids for a boolean operation to succeed.\nEach edge needs to be used from two polygons.  \nNon-neighboring polygons must not intersect each other.\n \nDue to these defects, the calculation may fail.\nAre you sure to proceed with the boolean operation?")
#define FSGUI_DLG_BOOL_DEFECTFOUND                        FsGetTextResource("dlg/bool/defectfound",L"Defects found")
#define FSGUI_DLG_BOOL_DIAGNOSE                           FsGetTextResource("dlg/bool/diagnose",L"Diagnose before Boolean Calculation")
#define FSGUI_DLG_BOOL_NONMANIFOLD                        FsGetTextResource("dlg/bool/nonmanifold",L" > Non-Manifold Edges - Use View->Highlight->Non-Manifold Edges to look for the problematic edges")
#define FSGUI_DLG_BOOL_PICKEDSHELL                        FsGetTextResource("dlg/bool/pickedshell",L"[Picked model]")
#define FSGUI_DLG_BOOL_POTENTIALPROBLEMS                  FsGetTextResource("dlg/bool/potentialproblems",L"Potential Problems")
#define FSGUI_DLG_BOOL_RECALCNORMAL                       FsGetTextResource("dlg/bool/recalcnormal",L"Recalculate Normal Vector before Boolean Calculation")
#define FSGUI_DLG_BOOL_SELFINTERSECTION                   FsGetTextResource("dlg/bool/selfintersection",L" > Self Intersections")
#define FSGUI_DLG_BOOL_TRIANGULATENONPLANAR               FsGetTextResource("dlg/bool/triangulatenonplanar",L"Triangulate Non-Planar Polygons before Calculation")
#define FSGUI_DLG_CHOPOFF_3VERTEX                         FsGetTextResource("dlg/chopoff/3vertex",L"Three Selected Vertices")
#define FSGUI_DLG_CHOPOFF_COPYTOBUFFER                    FsGetTextResource("dlg/chopoff/copytobuffer",L"Copy Dropped Part to the Cut Buffer")
#define FSGUI_DLG_CHOPOFF_DONTDROP                        FsGetTextResource("dlg/chopoff/dontdrop",L"Don't do anything.  Just make cutting.")
#define FSGUI_DLG_CHOPOFF_DROPLASTVERTEXSIDE              FsGetTextResource("dlg/chopoff/droplastvertexside",L"Drop Last-Vertex Side")
#define FSGUI_DLG_CHOPOFF_DROPSELVERTEXSIDE               FsGetTextResource("dlg/chopoff/dropselvertexside",L"Drop Selected-Vertex Side")
#define FSGUI_DLG_CHOPOFF_LEAVELASTVERTEXSIDE             FsGetTextResource("dlg/chopoff/leavelastvertexside",L"Leave Last-Vertex Side")
#define FSGUI_DLG_CHOPOFF_LEAVESELVERTEXSIDE              FsGetTextResource("dlg/chopoff/leaveselvertexside",L"Leave Selected-Vertex Side")
#define FSGUI_DLG_CHOPOFF_ONLYINTERSECTINGPART            FsGetTextResource("dlg/chopoff/onlyintersectingpart",L"Only Intersecting Part")
#define FSGUI_DLG_CHOPOFF_POLYGONORCONSTEDGE              FsGetTextResource("dlg/chopoff/polygonorconstedge",L"Selected Polygon or Constraint Edge")
#define FSGUI_DLG_CHOPOFF_WHOLEMODEL                      FsGetTextResource("dlg/chopoff/wholemodel",L"Whole Model")
#define FSGUI_DLG_CHOPOFF_XYPLANE                         FsGetTextResource("dlg/chopoff/xyplane",L"XY-Plane")
#define FSGUI_DLG_CHOPOFF_XYPLANEFIRSTVERTEX              FsGetTextResource("dlg/chopoff/xyplanefirstvertex",L"Parallel to XY-Plane Passing through the First Vertex")
#define FSGUI_DLG_CHOPOFF_XZPLANE                         FsGetTextResource("dlg/chopoff/xzplane",L"XZ-Plane")
#define FSGUI_DLG_CHOPOFF_XZPLANEFIRSTVERTEX              FsGetTextResource("dlg/chopoff/xzplanefirstvertex",L"Parallel to XZ-Plane Passing through the First Vertex")
#define FSGUI_DLG_CHOPOFF_YZPLANE                         FsGetTextResource("dlg/chopoff/yzplane",L"YZ-Plane")
#define FSGUI_DLG_CHOPOFF_YZPLANEFIRSTVERTEX              FsGetTextResource("dlg/chopoff/yzplanefirstvertex",L"Parallel to YZ-Plane Passing through the First Vertex")
#define FSGUI_DLG_COMMON_ASKCOPYTOCLIPBOARD               FsGetTextResource("dlg/common/askcopytoclipboard",L"Do you want to copy to clipboard instead?")
#define FSGUI_DLG_COMMON_CENTER                           FsGetTextResource("dlg/common/center",L"Center")
#define FSGUI_DLG_COMMON_COPYTOCLIPBOARD                  FsGetTextResource("dlg/common/copytoclipboard",L"Copy to Clipboard")
#define FSGUI_DLG_COMMON_CREATE                           FsGetTextResource("dlg/common/create",L"Create")
#define FSGUI_DLG_COMMON_DIVCOUNT                         FsGetTextResource("dlg/common/divcount",L"Division")
#define FSGUI_DLG_COMMON_ROTATE                           FsGetTextResource("dlg/common/rotate",L"Rotate")
#define FSGUI_DLG_COMMON_SCALINGFACTOR                    FsGetTextResource("dlg/common/scalingfactor",L"Scaling Factor")
#define FSGUI_DLG_COMMON_SHOW                             FsGetTextResource("dlg/common/show",L"Show")
#define FSGUI_DLG_CONFIG_AUTOADJUSTTOLERANCE              FsGetTextResource("dlg/config/autoadjusttolerance",L"Adjust Tolerance when Opening a File.")
#define FSGUI_DLG_CONFIG_AUTOFIXDNMORIENTATION            FsGetTextResource("dlg/config/autofixdnmorientation",L"Fix Polygon Orientation in DNM when opening")
#define FSGUI_DLG_CONFIG_LEFTHANDCOORD                    FsGetTextResource("dlg/config/lefthandcoord",L"Left-Hand Cooreinate (Direct3D, YSFLIGHT)")
#define FSGUI_DLG_CONFIG_RIGHTHANDCOORD                   FsGetTextResource("dlg/config/righthandcoord",L"Right-Hand Cooreinate (OpenGL)")
#define FSGUI_DLG_CONFIG_SAVEBINARYSTL                    FsGetTextResource("dlg/config/savebinarystl",L"Save STL in binary format")
#define FSGUI_DLG_CONFIG_SAVEWINDOWPOS                    FsGetTextResource("dlg/config/savewindowpos",L"Save Window Position and Size")
#define FSGUI_DLG_CONFIG_SETDEFAULT                       FsGetTextResource("dlg/config/setdefault",L"Set Default")
#define FSGUI_DLG_CONFIG_WHYAUTOFIXDNMORIENTATION         FsGetTextResource("dlg/config/whyautofixdnmorientation",L"Polygons in legacy DNM files may not be oriented correctly.\nBy checking this option, the program will fix polygon orientation based on the\nassigned normal vectors when the file is opened.")
#define FSGUI_DLG_CONFIRMCLOSE_MESSAGE                    FsGetTextResource("dlg/confirmclose/message",L"The model has been modified.  Really close?")
#define FSGUI_DLG_CONFIRMCLOSE_TITLE                      FsGetTextResource("dlg/confirmclose/title",L"Confirm Close?")
#define FSGUI_DLG_CONFIRMEXIT_MESSAGE                     FsGetTextResource("dlg/confirmexit/message",L"Some models have been modified. Exit anyway?")
#define FSGUI_DLG_CONFIRMEXIT_TITLE                       FsGetTextResource("dlg/confirmexit/title",L"Confirm Exit?")
#define FSGUI_DLG_CONFIRMOVERWRITE_MESSAGE                FsGetTextResource("dlg/confirmoverwrite/message",L"File Exists. Overwrite?")
#define FSGUI_DLG_CONFIRMOVERWRITE_TITLE                  FsGetTextResource("dlg/confirmoverwrite/title",L"Confirm Overwrite?")
#define FSGUI_DLG_CREATEPRIMITIVESHAPE_BOX                FsGetTextResource("dlg/createprimitiveshape/box",L"Box")
#define FSGUI_DLG_CREATEPRIMITIVESHAPE_CHANGEORIENTATION  FsGetTextResource("dlg/createprimitiveshape/changeorientation",L"Change Orientation")
#define FSGUI_DLG_CREATEPRIMITIVESHAPE_CONE               FsGetTextResource("dlg/createprimitiveshape/cone",L"Cone")
#define FSGUI_DLG_CREATEPRIMITIVESHAPE_CYLINDER           FsGetTextResource("dlg/createprimitiveshape/cylinder",L"Cylinder")
#define FSGUI_DLG_CREATEPRIMITIVESHAPE_ELLIPSOID          FsGetTextResource("dlg/createprimitiveshape/ellipsoid",L"Ellipsoid")
#define FSGUI_DLG_EQUILATERAL_1STVERTEX                   FsGetTextResource("dlg/equilateral/1stvertex",L"First Vertes Is:")
#define FSGUI_DLG_EQUILATERAL_BORDER                      FsGetTextResource("dlg/equilateral/border",L"On the border")
#define FSGUI_DLG_EQUILATERAL_CENTER                      FsGetTextResource("dlg/equilateral/center",L"Center")
#define FSGUI_DLG_EQUILATERAL_CURSOR_AS                   FsGetTextResource("dlg/equilateral/cursor_as",L"Cursor As:")
#define FSGUI_DLG_EQUILATERAL_CURSOR_AS_NORMAL            FsGetTextResource("dlg/equilateral/cursor_as_normal",L"Normal")
#define FSGUI_DLG_EQUILATERAL_CURSOR_AS_PASSINGPOINT      FsGetTextResource("dlg/equilateral/cursor_as_passingpoint",L"Passing Point")
#define FSGUI_DLG_EQUILATERAL_CURSOR_AS_TANGENT           FsGetTextResource("dlg/equilateral/cursor_as_tangent",L"Tangent")
#define FSGUI_DLG_EQUILATERAL_FIRSTHALF                   FsGetTextResource("dlg/equilateral/firsthalf",L"First Half")
#define FSGUI_DLG_EQUILATERAL_INCLUDE2ND                  FsGetTextResource("dlg/equilateral/include2nd",L"Include 2nd Vertex")
#define FSGUI_DLG_EQUILATERAL_INCLUDECURSOR               FsGetTextResource("dlg/equilateral/includecursor",L"Include Cursor Position")
#define FSGUI_DLG_EQUILATERAL_LASTHALF                    FsGetTextResource("dlg/equilateral/lasthalf",L"Last Half")
#define FSGUI_DLG_EQUILATERAL_WHOLE                       FsGetTextResource("dlg/equilateral/whole",L"Whole")
#define FSGUI_DLG_FACEGROUPONAME_NAME                     FsGetTextResource("dlg/facegrouponame/name",L"Face Group Name")
#define FSGUI_DLG_HELP_HELPMSG                            FsGetTextResource("dlg/help/helpmsg",L"Help can be found in the following URL.")
#define FSGUI_DLG_HELP_HELPURL                            FsGetTextResource("dlg/help/helpurl",L"http://polycre.help.en.ysflight.com")
#define FSGUI_DLG_INSERTVERTEX_ADDVERTEXTOSELECTION       FsGetTextResource("dlg/insertvertex/addvertextoselection",L"Add New Vertices to Selection")
#define FSGUI_DLG_INSERTVERTEX_CHANGESCHEME               FsGetTextResource("dlg/insertvertex/changescheme",L"Change Point-Input Scheme")
#define FSGUI_DLG_OPENDNM_CONFIRMCLOSE_MESSAGE            FsGetTextResource("dlg/opendnm/confirmclose/message",L"All changes will be discarded when a DNM file is opened.\nAre you ok with discarding changes?")
#define FSGUI_DLG_OPENDNM_CONFIRMCLOSE_TITLE              FsGetTextResource("dlg/opendnm/confirmclose/title",L"Confirm discard changes")
#define FSGUI_DLG_PARALLELOGRAM_CANCELLAST                FsGetTextResource("dlg/parallelogram/cancellast",L"Cancel Last")
#define FSGUI_DLG_PARALLELOGRAM_CLOSELOOP                 FsGetTextResource("dlg/parallelogram/closeloop",L"Close Loop")
#define FSGUI_DLG_PARALLELOGRAM_CLOSELOOPFLOORCEILING     FsGetTextResource("dlg/parallelogram/closeloopfloorceiling",L"Close Loop, Floor, and Ceiling")
#define FSGUI_DLG_REFBMP_DISCARDIMAGE                     FsGetTextResource("dlg/refbmp/discardimage",L"Discard Image")
#define FSGUI_DLG_REFBMP_LOADIMAGE                        FsGetTextResource("dlg/refbmp/loadimage",L"Load PNG/BMP Image")
#define FSGUI_DLG_REFBMP_MOVESCALE                        FsGetTextResource("dlg/refbmp/movescale",L"Move/Scale")
#define FSGUI_DLG_REFBMP_XY                               FsGetTextResource("dlg/refbmp/xy",L"XY(Front)")
#define FSGUI_DLG_REFBMP_XZ                               FsGetTextResource("dlg/refbmp/xz",L"XZ(Top)")
#define FSGUI_DLG_REFBMP_YZ                               FsGetTextResource("dlg/refbmp/yz",L"YZ(Side)")
#define FSGUI_DLG_SAVED_TITLE                             FsGetTextResource("dlg/saved/title",L"Saved.")
#define FSGUI_DLG_SCALING_CENTERATORIGIN                  FsGetTextResource("dlg/scaling/centeratorigin",L"Set Scaling Center at Origin")
#define FSGUI_DLG_SCALING_ISOTROPICSCALING                FsGetTextResource("dlg/scaling/isotropicscaling",L"Isotropic Scaling")
#define FSGUI_DLG_SELECTBYPROP_ADDSELECTBTN               FsGetTextResource("dlg/selectbyprop/addselectbtn",L"Add to Selection")
#define FSGUI_DLG_SELECTBYPROP_CEBYID                     FsGetTextResource("dlg/selectbyprop/cebyid",L"Const-Edge Id")
#define FSGUI_DLG_SELECTBYPROP_CEBYLABEL                  FsGetTextResource("dlg/selectbyprop/cebylabel",L"Const-Edge Label")
#define FSGUI_DLG_SELECTBYPROP_CEKEY                      FsGetTextResource("dlg/selectbyprop/cekey",L"Const-Edge Hash Key")
#define FSGUI_DLG_SELECTBYPROP_FGBYID                     FsGetTextResource("dlg/selectbyprop/fgbyid",L"Face-Group Id")
#define FSGUI_DLG_SELECTBYPROP_FGBYLABEL                  FsGetTextResource("dlg/selectbyprop/fgbylabel",L"Face-Group Label")
#define FSGUI_DLG_SELECTBYPROP_FGKEY                      FsGetTextResource("dlg/selectbyprop/fgkey",L"Face-Group Hash Key")
#define FSGUI_DLG_SELECTBYPROP_HIGHASPECTPOLYGON          FsGetTextResource("dlg/selectbyprop/highaspectpolygon",L"High Aspect-Ratio Polygon")
#define FSGUI_DLG_SELECTBYPROP_PLGIDBTN                   FsGetTextResource("dlg/selectbyprop/plgidbtn",L"Polygon Index")
#define FSGUI_DLG_SELECTBYPROP_PLGKEYBTN                  FsGetTextResource("dlg/selectbyprop/plgkeybtn",L"Polygon Hash Key")
#define FSGUI_DLG_SELECTBYPROP_REMOVESELECTBTN            FsGetTextResource("dlg/selectbyprop/removeselectbtn",L"Remove from Selection")
#define FSGUI_DLG_SELECTBYPROP_SELECTBTN                  FsGetTextResource("dlg/selectbyprop/selectbtn",L"Select")
#define FSGUI_DLG_SELECTBYPROP_VTKEYBTN                   FsGetTextResource("dlg/selectbyprop/vtkeybtn",L"Vertex Internal Hash Key")
#define FSGUI_DLG_SELECTBYPROP_VTXIDBTN                   FsGetTextResource("dlg/selectbyprop/vtxidbtn",L"Vertex Index")
#define FSGUI_DLG_SETALPHA_SOLID                          FsGetTextResource("dlg/setalpha/solid",L"Solid")
#define FSGUI_DLG_SETALPHA_TRANSPARENT                    FsGetTextResource("dlg/setalpha/transparent",L"Transparent")
#define FSGUI_DLG_SLIDESHOW_CHANGEVIEW                    FsGetTextResource("dlg/slideshow/changeview",L"Change View for Each File")
#define FSGUI_DLG_SLIDESHOW_NEXT                          FsGetTextResource("dlg/slideshow/next",L"Next>>")
#define FSGUI_DLG_SLIDESHOW_PREV                          FsGetTextResource("dlg/slideshow/prev",L"<<Previous")
#define FSGUI_DLG_SOLREV_ANGLE                            FsGetTextResource("dlg/solrev/angle",L"Angle")
#define FSGUI_DLG_SOLREV_CLOSED                           FsGetTextResource("dlg/solrev/closed",L"Closed")
#define FSGUI_DLG_SOLREV_DISPLACEMENT                     FsGetTextResource("dlg/solrev/displacement",L"Displacement")
#define FSGUI_DLG_SOLREV_STEPANGLE                        FsGetTextResource("dlg/solrev/stepangle",L"Step Angle")
#define FSGUI_DLG_SWEEPCONSTEDGE_INVERT                   FsGetTextResource("dlg/sweepconstedge/invert",L"Invert Normal Vectors")
#define FSGUI_DLG_SWEEPCONSTEDGE_SWEEP                    FsGetTextResource("dlg/sweepconstedge/sweep",L"Sweep")
#define FSGUI_DLG_SWEEP_DELSRCPLG                         FsGetTextResource("dlg/sweep/delsrcplg",L"Delete Source Polygons")
#define FSGUI_DLG_VERTEXPOSITION_VERTEXPOSITION           FsGetTextResource("dlg/vertexposition/vertexposition",L"Vertex Position")
#define FSGUI_ERROR_CANNOTCALCULATENORMAL                 FsGetTextResource("error/cannotcalculatenormal",L"Cannot calculate normal vector.")
#define FSGUI_ERROR_CANNOTIDENTIFYWHICHSIDETODROP         FsGetTextResource("error/cannotidentifywhichsidetodrop",L"Cannot identify which side to drop.")
#define FSGUI_ERROR_CANNOTMAKECONSTEDGECHAIN              FsGetTextResource("error/cannotmakeconstedgechain",L"Cannot make a const-edge chain")
#define FSGUI_ERROR_CANNOTROUNDPLGBOUNDARY                FsGetTextResource("error/cannotroundplgboundary",L"Cannot round specified polygon boundary.")
#define FSGUI_ERROR_CANNOTROUNDVTX                        FsGetTextResource("error/cannotroundvtx",L"Cannot round specified vertices")
#define FSGUI_ERROR_DIVCOUNTOUTOF1AND256                  FsGetTextResource("error/divcountoutof1and256",L"Division count needs to be between 1 and 256.")
#define FSGUI_ERROR_NEEDSELECT1POLYGON                    FsGetTextResource("error/needselect1polygon",L"Please select 1 polygon and try again.")
#define FSGUI_ERROR_NEEDSELECT2POLYGON                    FsGetTextResource("error/needselect2polygon",L"Please select 2 polygons and try again.")
#define FSGUI_ERROR_NEEDSELECT2VERTEX                     FsGetTextResource("error/needselect2vertex",L"Please select 2 vertices and try again.")
#define FSGUI_ERROR_NEEDSELECT3VERTEX                     FsGetTextResource("error/needselect3vertex",L"Please select 3 vertices and try again.")
#define FSGUI_ERROR_NEEDSELECTATLEAST1CONSTEDGE           FsGetTextResource("error/needselectatleast1constedge",L"At least 1 const-edge must be selected.")
#define FSGUI_ERROR_NEEDSELECTATLEAST1VERTEX              FsGetTextResource("error/needselectatleast1vertex",L"At least 1 vertex must be selected")
#define FSGUI_ERROR_NEEDSELECTATLEAST2VERTEX              FsGetTextResource("error/needselectatleast2vertex",L"At least 2 vertices must be selected")
#define FSGUI_ERROR_NEEDSELECTATLEAST3VERTEX              FsGetTextResource("error/needselectatleast3vertex",L"At least 3 vertices must be selected")
#define FSGUI_ERROR_NEEDSELECTATLEAST4VERTEX              FsGetTextResource("error/needselectatleast4vertex",L"At least 4 vertices must be selected")
#define FSGUI_ERROR_NEEDSELECTCONSTEDGE                   FsGetTextResource("error/needselectconstedge",L"At least one const-edge must be selected.")
#define FSGUI_ERROR_NEEDSELECTONEPLGORCONSTEDGE           FsGetTextResource("error/needselectoneplgorconstedge",L"Please select at least one polygon or const-edge")
#define FSGUI_ERROR_NEEDSELECTVTXANDPLGORFGORCE           FsGetTextResource("error/needselectvtxandplgorfgorce",L"At least 1 vertex and a polygon, const-edge, or face group must be selected")
#define FSGUI_ERROR_NEEDSELECTVTXORCONSTEDGE              FsGetTextResource("error/needselectvtxorconstedge",L"Select either vertices or const edges.")
#define FSGUI_ERROR_NEED_1OR2_VERTEX                      FsGetTextResource("error/need_1or2_vertex",L"Need 1 or 2 vertices selected.")
#define FSGUI_ERROR_SOLREV_SELECTION                      FsGetTextResource("error/solrev/selection",L"Please select source (polygons or const-edges)\nand then axis (a const-edge or two vertices), and try again.")
#define FSGUI_ERROR_SWEEP_NEEDPATHANDSRC                  FsGetTextResource("error/sweep/needpathandsrc",L"Please select source (polygons and/or face group)\nand path (one constraint edge)\nYou can also select an additional constraint edge as a guide rail.")
#define FSGUI_ERROR_TOOMANYSELECTION                      FsGetTextResource("error/toomanyselection",L"Too Many Elements are Selected")
#define FSGUI_ERROR_TRIANGULATIONERROR                    FsGetTextResource("error/triangulationerror",L"Some polygons could not be triangulated.")
#define FSGUI_MENU_BOOLEAN                                FsGetTextResource("menu/boolean",L"Boolean")
#define FSGUI_MENU_BOOL_INTERSECTION                      FsGetTextResource("menu/bool/intersection",L"Intersection")
#define FSGUI_MENU_BOOL_MERGE                             FsGetTextResource("menu/bool/merge",L"Merge")
#define FSGUI_MENU_BOOL_OPENANDSOLID                      FsGetTextResource("menu/bool/openandsolid",L"Open Surface AND Solid")
#define FSGUI_MENU_BOOL_OPENMINUSSOLID                    FsGetTextResource("menu/bool/openminussolid",L"Open Surface minus Solid")
#define FSGUI_MENU_BOOL_OPENPLUSSOLID                     FsGetTextResource("menu/bool/openplussolid",L"Open Surface plus Solid")
#define FSGUI_MENU_BOOL_SEPARATE                          FsGetTextResource("menu/bool/separate",L"Separate")
#define FSGUI_MENU_BOOL_SUBTRACTION                       FsGetTextResource("menu/bool/subtraction",L"Subtraction")
#define FSGUI_MENU_BOOL_UNION                             FsGetTextResource("menu/bool/union",L"Union")
#define FSGUI_MENU_DNM_EDITTREESTRUCTURE                  FsGetTextResource("menu/dnm/edittreestructure",L"Edit Tree Structure")
#define FSGUI_MENU_DNM_LOADSTATE0                         FsGetTextResource("menu/dnm/loadstate0",L"Load State 0")
#define FSGUI_MENU_DNM_LOADSTATE1                         FsGetTextResource("menu/dnm/loadstate1",L"Load State 1")
#define FSGUI_MENU_DNM_LOADSTATE2                         FsGetTextResource("menu/dnm/loadstate2",L"Load State 2")
#define FSGUI_MENU_DNM_LOADSTATE3                         FsGetTextResource("menu/dnm/loadstate3",L"Load State 3")
#define FSGUI_MENU_DNM_LOADSTATICMODE                     FsGetTextResource("menu/dnm/loadstaticmode",L"Load Static Mode")
#define FSGUI_MENU_DNM_PREVIEW                            FsGetTextResource("menu/dnm/preview",L"Preview")
#define FSGUI_MENU_DNM_SETNAME                            FsGetTextResource("menu/dnm/setname",L"Set Name and Attributes")
#define FSGUI_MENU_DYNAMICMODEL                           FsGetTextResource("menu/dynamicmodel",L"Dynamic Model")
#define FSGUI_MENU_EDIT                                   FsGetTextResource("menu/edit",L"Edit")
#define FSGUI_MENU_EDIT_CLEARUIMODE                       FsGetTextResource("menu/edit/clearuimode",L"Clear UI mode\tESC")
#define FSGUI_MENU_EDIT_COPY                              FsGetTextResource("menu/edit/copy",L"Copy\tCtrl+C")
#define FSGUI_MENU_EDIT_CREATE                            FsGetTextResource("menu/edit/create",L"Create")
#define FSGUI_MENU_EDIT_CREATE_AIRFOIL                    FsGetTextResource("menu/edit/create/airfoil",L"Airfoil")
#define FSGUI_MENU_EDIT_CREATE_CONEFROMVTXANDPLG          FsGetTextResource("menu/edit/create/conefromvtxandplg",L"Cone from Selected Vertex and Polygon, Face Group, or Const-Edge")
#define FSGUI_MENU_EDIT_CREATE_EQUILATERAL                FsGetTextResource("menu/edit/create/equilateral",L"Equilateral")
#define FSGUI_MENU_EDIT_CREATE_MIRRORIMAGE                FsGetTextResource("menu/edit/create/mirrorimage",L"Mirror Image")
#define FSGUI_MENU_EDIT_CREATE_PARALLELOGRAMFROMTHREEVTX  FsGetTextResource("menu/edit/create/parallelogramfromthreevtx",L"Parallelogram from Three Selected Vertices")
#define FSGUI_MENU_EDIT_CREATE_PARALLELOGRAMFROMTWOVTX    FsGetTextResource("menu/edit/create/parallelogramfromtwovtx",L"Parallelogram from Two Selected Vertices")
#define FSGUI_MENU_EDIT_CREATE_PRIMITIVESHAPE             FsGetTextResource("menu/edit/create/primitiveshape",L"Primitive Shape")
#define FSGUI_MENU_EDIT_CREATE_SOLIDOFREVOLUTION          FsGetTextResource("menu/edit/create/solidofrevolution",L"Solid of Revolution")
#define FSGUI_MENU_EDIT_DELETE                            FsGetTextResource("menu/edit/delete",L"Delete")
#define FSGUI_MENU_EDIT_DELETE_ALLSELECTION               FsGetTextResource("menu/edit/delete/allselection",L"All Selection\tDEL")
#define FSGUI_MENU_EDIT_FLATSHADESELECTEDVERTEX           FsGetTextResource("menu/edit/flatshadeselectedvertex",L"Flat-Shade Selected Vertices")
#define FSGUI_MENU_EDIT_FORCEDELETESELECTION              FsGetTextResource("menu/edit/forcedeleteselection",L"Force Delete All Selection\tShift+DEL")
#define FSGUI_MENU_EDIT_INSERT                            FsGetTextResource("menu/edit/insert",L"Insert")
#define FSGUI_MENU_EDIT_INSERT_CONSTEDGE                  FsGetTextResource("menu/edit/insert/constedge",L"Constraint Edge\tE")
#define FSGUI_MENU_EDIT_INSERT_FACEGROUP                  FsGetTextResource("menu/edit/insert/facegroup",L"Face Group")
#define FSGUI_MENU_EDIT_INSERT_POLYGON                    FsGetTextResource("menu/edit/insert/polygon",L"Polygon\tF")
#define FSGUI_MENU_EDIT_INSERT_VERTEX                     FsGetTextResource("menu/edit/insert/vertex",L"Vertex\tV")
#define FSGUI_MENU_EDIT_INTERSECTION                      FsGetTextResource("menu/edit/intersection",L"Intersection")
#define FSGUI_MENU_EDIT_INTERSECTION_CHOPOFF              FsGetTextResource("menu/edit/intersection/chopoff",L"Chop Off")
#define FSGUI_MENU_EDIT_INTERSECTION_CUTBYPLANE           FsGetTextResource("menu/edit/intersection/cutbyplane",L"Cut by Plane ")
#define FSGUI_MENU_EDIT_LOCAL                             FsGetTextResource("menu/edit/local",L"Local Modification")
#define FSGUI_MENU_EDIT_LOCAL_HEMMINGAROUNDPLG            FsGetTextResource("menu/edit/local/hemmingaroundplg",L"Hemming - Around Selected Polygons")
#define FSGUI_MENU_EDIT_LOCAL_HEMMINGONESIDEVTXSEQ        FsGetTextResource("menu/edit/local/hemmingonesidevtxseq",L"Hemming - One Side of a Vertex Sequence")
#define FSGUI_MENU_EDIT_LOCAL_HEMMINGOUTSIDEPLG           FsGetTextResource("menu/edit/local/hemmingoutsideplg",L"Hemming - Outside of Selected Polygons")
#define FSGUI_MENU_EDIT_LOCAL_INVERTCONSTEDGE             FsGetTextResource("menu/edit/local/invertconstedge",L"Invert Const Edge")
#define FSGUI_MENU_EDIT_LOCAL_INVERTSELECTEDPOLYGON       FsGetTextResource("menu/edit/local/invertselectedpolygon",L"Invert Selected Polygons")
#define FSGUI_MENU_EDIT_LOCAL_MERGECONSTEDGE              FsGetTextResource("menu/edit/local/mergeconstedge",L"Merge Constraint Edge")
#define FSGUI_MENU_EDIT_LOCAL_MERGEPLG                    FsGetTextResource("menu/edit/local/mergeplg",L"Merge Selected Polygons\tG")
#define FSGUI_MENU_EDIT_LOCAL_MERGEVTXATOB                FsGetTextResource("menu/edit/local/mergevtxatob",L"Merge Vertices - Vertex A to Vertex B\tShift+D")
#define FSGUI_MENU_EDIT_LOCAL_MERGEVTXMIDPOINT            FsGetTextResource("menu/edit/local/mergevtxmidpoint",L"Merge Vertices - Mid Point")
#define FSGUI_MENU_EDIT_LOCAL_SEWBETWEENVTXS              FsGetTextResource("menu/edit/local/sewbetweenvtxs",L"Sew between Selected Vertices")
#define FSGUI_MENU_EDIT_LOCAL_SPLITCONSTEDGE              FsGetTextResource("menu/edit/local/splitconstedge",L"Split Constraint Edge")
#define FSGUI_MENU_EDIT_LOCAL_SPLITPLG                    FsGetTextResource("menu/edit/local/splitplg",L"Split Polygons\tS")
#define FSGUI_MENU_EDIT_LOCAL_SWAPEDGE                    FsGetTextResource("menu/edit/local/swapedge",L"Edge Swapping\tW")
#define FSGUI_MENU_EDIT_LOCAL_TRIANGULATESELECTION        FsGetTextResource("menu/edit/local/triangulateselection",L"Triangulate Selected Polygons")
#define FSGUI_MENU_EDIT_MOVE                              FsGetTextResource("menu/edit/move",L"Move")
#define FSGUI_MENU_EDIT_MOVESELECTION                     FsGetTextResource("menu/edit/moveselection",L"Move Selection")
#define FSGUI_MENU_EDIT_MOVE_PRESELECTDIRECTION_FROMNORMAL FsGetTextResource("menu/edit/move/preselectdirection/fromnormal",L"Pre-Select Direction from Normal")
#define FSGUI_MENU_EDIT_MOVE_SELECTION_PRESELECTEDDIRECTION FsGetTextResource("menu/edit/move/selection/preselecteddirection",L"Move Selection in Pre-Selected Direction")
#define FSGUI_MENU_EDIT_MOVE_SELECTION_PRESELECTEDDIRECTION_SPECIFYDIST FsGetTextResource("menu/edit/move/selection/preselecteddirection/specifydist",L"Move Selection in Pre-Selected Direction Specified Distance")
#define FSGUI_MENU_EDIT_OFFSET                            FsGetTextResource("menu/edit/offset",L"Offset")
#define FSGUI_MENU_EDIT_OFFSET_THICKENING                 FsGetTextResource("menu/edit/offset/thickening",L"Thickening")
#define FSGUI_MENU_EDIT_PAINT                             FsGetTextResource("menu/edit/paint",L"Paint")
#define FSGUI_MENU_EDIT_PAINT_ALL                         FsGetTextResource("menu/edit/paint/all",L"All")
#define FSGUI_MENU_EDIT_PAINT_BYPICKINGFG                 FsGetTextResource("menu/edit/paint/bypickingfg",L"by Picking a Face Groupn")
#define FSGUI_MENU_EDIT_PAINT_BYPICKINGPLG                FsGetTextResource("menu/edit/paint/bypickingplg",L"by Picking a Polygon")
#define FSGUI_MENU_EDIT_PAINT_FLOODFILLCONSTEDGE          FsGetTextResource("menu/edit/paint/floodfillconstedge",L"Flood Fill - Bounded by Const Edges")
#define FSGUI_MENU_EDIT_PAINT_FLOODFILLSAMECOLOR          FsGetTextResource("menu/edit/paint/floodfillsamecolor",L"Flood Fill - Same Color")
#define FSGUI_MENU_EDIT_PAINT_SELECTEDPLG                 FsGetTextResource("menu/edit/paint/selectedplg",L"Selected Polygons")
#define FSGUI_MENU_EDIT_PASTE                             FsGetTextResource("menu/edit/paste",L"Paste\tCtrl+V")
#define FSGUI_MENU_EDIT_PASTESPECIAL                      FsGetTextResource("menu/edit/pastespecial",L"Paste Special")
#define FSGUI_MENU_EDIT_PROJECTION                        FsGetTextResource("menu/edit/projection",L"Projection")
#define FSGUI_MENU_EDIT_PROJECTION_IMPRINTING             FsGetTextResource("menu/edit/projection/imprinting",L"Imprint Selection")
#define FSGUI_MENU_EDIT_PROJECTION_OPENPROJDIALOG         FsGetTextResource("menu/edit/projection/openprojdialog",L"Open Projection Dialog")
#define FSGUI_MENU_EDIT_REDO                              FsGetTextResource("menu/edit/redo",L"Redo\tCtrl+Y")
#define FSGUI_MENU_EDIT_RENDERINGOPTION                   FsGetTextResource("menu/edit/renderingoption",L"Rendering Options")
#define FSGUI_MENU_EDIT_RENDERINGOPTION_BREAKSMOOTHSHADING FsGetTextResource("menu/edit/renderingoption/breaksmoothshading",L"Break Smooth Shading on Selected Const Edges")
#define FSGUI_MENU_EDIT_RENDERINGOPTION_SETPOLYGONALPHA   FsGetTextResource("menu/edit/renderingoption/setpolygonalpha",L"Set Alpha (Transparency) of Selected Polygons")
#define FSGUI_MENU_EDIT_RENDERINGOPTION_SETSHADEDPOLYGON  FsGetTextResource("menu/edit/renderingoption/setshadedpolygon",L"Selected Polygons are Shaded")
#define FSGUI_MENU_EDIT_RENDERINGOPTION_SETUNSHADEDPOLYGON FsGetTextResource("menu/edit/renderingoption/setunshadedpolygon",L"Selected Polygons are Self-Lighting (No Shading)")
#define FSGUI_MENU_EDIT_RENDERINGOPTION_SMOOTHSHADINGONCONSTEDGE FsGetTextResource("menu/edit/renderingoption/smoothshadingonconstedge",L"Smooth Shading on Selected Const Edges")
#define FSGUI_MENU_EDIT_ROTATESELECTION                   FsGetTextResource("menu/edit/rotateselection",L"Rotate Selection")
#define FSGUI_MENU_EDIT_ROUND                             FsGetTextResource("menu/edit/round",L"Round")
#define FSGUI_MENU_EDIT_ROUND_ALONGVERTEXSEQ              FsGetTextResource("menu/edit/round/alongvertexseq",L"Along Selected Vertex Sequence or Const Edge")
#define FSGUI_MENU_EDIT_ROUND_AROUNDSELECTEDPOLYGONS      FsGetTextResource("menu/edit/round/aroundselectedpolygons",L"Around Selected Polygons")
#define FSGUI_MENU_EDIT_ROUND_AROUNDSELECTEDVERTEX        FsGetTextResource("menu/edit/round/aroundselectedvertex",L"Around Selected Vertex")
#define FSGUI_MENU_EDIT_ROUND_POLYGON_CONSTEDGE_ALLCORNERS FsGetTextResource("menu/edit/round/polygon_constedge_allcorners",L"Polygon/Const-Edge All Corners")
#define FSGUI_MENU_EDIT_ROUND_POLYGON_CONSTEDGE_SELECTEDCORNERS FsGetTextResource("menu/edit/round/polygon_constedge_selectedcorners",L"Polygon/Const-Edge Selected Corners")
#define FSGUI_MENU_EDIT_SCALESELECTION                    FsGetTextResource("menu/edit/scaleselection",L"Scale Selection")
#define FSGUI_MENU_EDIT_SMOOTHSHADESELECTEDVERTEX         FsGetTextResource("menu/edit/smoothshadeselectedvertex",L"Smooth-Shade Selected Vertices")
#define FSGUI_MENU_EDIT_SWEEP                             FsGetTextResource("menu/edit/sweep",L"Sweep")
#define FSGUI_MENU_EDIT_SWEEP_BETWEENCE                   FsGetTextResource("menu/edit/sweep/betweence",L"Between Const Edges")
#define FSGUI_MENU_EDIT_SWEEP_EXTENDORSHRINK              FsGetTextResource("menu/edit/sweep/extendorshrink",L"Extend or Shrink")
#define FSGUI_MENU_EDIT_SWEEP_NONPARALLELSWEEPWITHPATH    FsGetTextResource("menu/edit/sweep/nonparallelsweepwithpath",L"Non-Parallel Sweeping with Path")
#define FSGUI_MENU_EDIT_SWEEP_PARALLEL                    FsGetTextResource("menu/edit/sweep/parallel",L"Parallel Sweeping")
#define FSGUI_MENU_EDIT_SWEEP_PARALLELWITHPATH            FsGetTextResource("menu/edit/sweep/parallelwithpath",L"Parallel Sweeping with Path")
#define FSGUI_MENU_EDIT_UNDO                              FsGetTextResource("menu/edit/undo",L"Undo\tCtrl+Z")
#define FSGUI_MENU_FILE                                   FsGetTextResource("menu/file",L"File")
#define FSGUI_MENU_FILE_CLOSE                             FsGetTextResource("menu/file/close",L"Close")
#define FSGUI_MENU_FILE_EXIT                              FsGetTextResource("menu/file/exit",L"Exit")
#define FSGUI_MENU_FILE_GETINFO                           FsGetTextResource("menu/file/getinfo",L"Get Info")
#define FSGUI_MENU_FILE_GETINFO_ANGLE                     FsGetTextResource("menu/file/getinfo/angle",L"Angle")
#define FSGUI_MENU_FILE_GETINFO_ANGLE_DIHEDRALANGLE       FsGetTextResource("menu/file/getinfo/angle/dihedralangle",L"Dihedral Angle between Polygons Sharing Two Selected Vertices")
#define FSGUI_MENU_FILE_GETINFO_ANGLE_NORMALDEVIATIONACROSSCONSTEDGE FsGetTextResource("menu/file/getinfo/angle/normaldeviationacrossconstedge",L"Normal Deviation across Const-Edge")
#define FSGUI_MENU_FILE_GETINFO_ANGLE_TWOPOLYGON          FsGetTextResource("menu/file/getinfo/angle/twopolygon",L"Angle between Two Selected Polygons")
#define FSGUI_MENU_FILE_GETINFO_AREA                      FsGetTextResource("menu/file/getinfo/area",L"Area")
#define FSGUI_MENU_FILE_GETINFO_AREA_ALL                  FsGetTextResource("menu/file/getinfo/area/all",L"All")
#define FSGUI_MENU_FILE_GETINFO_AREA_SELECTEDPOLYGON      FsGetTextResource("menu/file/getinfo/area/selectedpolygon",L"Selected Polygons")
#define FSGUI_MENU_FILE_GETINFO_DEBUGINFO                 FsGetTextResource("menu/file/getinfo/debuginfo",L"Debug Info")
#define FSGUI_MENU_FILE_GETINFO_DEBUGINFO_OFSELECTION     FsGetTextResource("menu/file/getinfo/debuginfo/ofselection",L"Of Selcted Elements")
#define FSGUI_MENU_FILE_GETINFO_LENGTH                    FsGetTextResource("menu/file/getinfo/length",L"Length/Distance")
#define FSGUI_MENU_FILE_GETINFO_LENGTH_BETWEENVTX         FsGetTextResource("menu/file/getinfo/length/betweenvtx",L"Between Selected Vertices")
#define FSGUI_MENU_FILE_GETINFO_LENGTH_CONSTEDGE          FsGetTextResource("menu/file/getinfo/length/constedge",L"Selected Const-Edges")
#define FSGUI_MENU_FILE_GETINFO_POSITION                  FsGetTextResource("menu/file/getinfo/position",L"Position")
#define FSGUI_MENU_FILE_GETINFO_POSITION_SELVTX           FsGetTextResource("menu/file/getinfo/position/selvtx",L"Selected Vertices")
#define FSGUI_MENU_FILE_GETINFO_STATISTICS                FsGetTextResource("menu/file/getinfo/statistics",L"Show Statistics")
#define FSGUI_MENU_FILE_GETINFO_VOLUME                    FsGetTextResource("menu/file/getinfo/volume",L"Show Total Volume")
#define FSGUI_MENU_FILE_LOADERROR                         FsGetTextResource("menu/file/loaderror",L"Cannot open file")
#define FSGUI_MENU_FILE_NEW                               FsGetTextResource("menu/file/new",L"New")
#define FSGUI_MENU_FILE_OPEN                              FsGetTextResource("menu/file/open",L"Open")
#define FSGUI_MENU_FILE_OPENDNM                           FsGetTextResource("menu/file/opendnm",L"Open DNM")
#define FSGUI_MENU_FILE_RECENT                            FsGetTextResource("menu/file/recent",L"Recent Files...")
#define FSGUI_MENU_FILE_SAVE                              FsGetTextResource("menu/file/save",L"Save")
#define FSGUI_MENU_FILE_SAVEAS                            FsGetTextResource("menu/file/saveas",L"Save As")
#define FSGUI_MENU_FILE_SLIDESHOW                         FsGetTextResource("menu/file/slideshow",L"Slide Show")
#define FSGUI_MENU_GLOBAL                                 FsGetTextResource("menu/global",L"Global")
#define FSGUI_MENU_GLOBAL_DELETEUNUSED                    FsGetTextResource("menu/global/deleteunused",L"Delete All Unused Vertices")
#define FSGUI_MENU_GLOBAL_INVERTPOLYGON                   FsGetTextResource("menu/global/invertpolygon",L"Invert All Polygons")
#define FSGUI_MENU_GLOBAL_MERGESAMEVERTEX                 FsGetTextResource("menu/global/mergesamevertex",L"Merge Vertices at the Same Location")
#define FSGUI_MENU_GLOBAL_MERGESAMEVERTEXONNONMANIFOLDEDGE FsGetTextResource("menu/global/mergesamevertexonnonmanifoldedge",L"Merge Vertices at the Same Location (on Non-Manifold Edges only)")
#define FSGUI_MENU_GLOBAL_RENORMAL_CURRENT_ORIENTATION    FsGetTextResource("menu/global/renormal_current_orientation",L"Re-calculate Normal Vectors from Current Orientations")
#define FSGUI_MENU_GLOBAL_REORIENT                        FsGetTextResource("menu/global/reorient",L"Recalculate Polygon Orientation")
#define FSGUI_MENU_GLOBAL_REORIENT_ASSIGNED_NORMAL        FsGetTextResource("menu/global/reorient_assigned_normal",L"Fix Orientations assuming Assigned Normal Vector is Reliable")
#define FSGUI_MENU_GLOBAL_TARGET                          FsGetTextResource("menu/global/target",L"Applied to...")
#define FSGUI_MENU_GLOBAL_TARGET_ALL                      FsGetTextResource("menu/global/target/all",L"All Models")
#define FSGUI_MENU_GLOBAL_TARGET_CURRENT                  FsGetTextResource("menu/global/target/current",L"Current Model Only")
#define FSGUI_MENU_GLOBAL_TRIANGULATE                     FsGetTextResource("menu/global/triangulate",L"Triangulate All")
#define FSGUI_MENU_GLOBAL_ZERONORMAL                      FsGetTextResource("menu/global/zeronormal",L"Set Zero Normal to All Polygons")
#define FSGUI_MENU_HELP                                   FsGetTextResource("menu/help",L"Help")
#define FSGUI_MENU_HELP_ABOUT                             FsGetTextResource("menu/help/about",L"About")
#define FSGUI_MENU_HELP_HELP                              FsGetTextResource("menu/help/help",L"Help")
#define FSGUI_MENU_OPTION                                 FsGetTextResource("menu/option",L"Option")
#define FSGUI_MENU_OPTION_CONFIG                          FsGetTextResource("menu/option/config",L"Config")
#define FSGUI_MENU_SELECT                                 FsGetTextResource("menu/select",L"Select")
#define FSGUI_MENU_SELECT_BYPROP                          FsGetTextResource("menu/select/byprop",L"by Properties")
#define FSGUI_MENU_SELECT_CONSTEDGE                       FsGetTextResource("menu/select/constedge",L"Const Edges")
#define FSGUI_MENU_SELECT_CONSTEDGE_ALL                   FsGetTextResource("menu/select/constedge/all",L"All Const Edges")
#define FSGUI_MENU_SELECT_CONSTEDGE_DIVIDINGSMOOTHSHADINGREGION FsGetTextResource("menu/select/constedge/dividingsmoothshadingregion",L"Dividing Smooth-Shading Regions")
#define FSGUI_MENU_SELECT_CONSTEDGE_INVERT                FsGetTextResource("menu/select/constedge/invert",L"Invert Selection")
#define FSGUI_MENU_SELECT_FACEGROUP                       FsGetTextResource("menu/select/facegroup",L"Face Groups")
#define FSGUI_MENU_SELECT_FACEGROUP_ALL                   FsGetTextResource("menu/select/facegroup/all",L"All")
#define FSGUI_MENU_SELECT_FACEGROUP_HIGHDHA               FsGetTextResource("menu/select/facegroup/highdha",L"Select Face Groups that Include High Dihedral Angle")
#define FSGUI_MENU_SELECT_FACEGROUP_INVERT                FsGetTextResource("menu/select/facegroup/invert",L"Invert Selection")
#define FSGUI_MENU_SELECT_FACEGROUP_PLANARFACEGROUP       FsGetTextResource("menu/select/facegroup/planarfacegroup",L"Planar Face Groups")
#define FSGUI_MENU_SELECT_PICK                            FsGetTextResource("menu/select/pick",L"Pick")
#define FSGUI_MENU_SELECT_PICK_CONSTEDGE                  FsGetTextResource("menu/select/pick/constedge",L"Const Edge\tShift+E")
#define FSGUI_MENU_SELECT_PICK_FACEGROUP                  FsGetTextResource("menu/select/pick/facegroup",L"Face Group")
#define FSGUI_MENU_SELECT_PICK_POLYGON                    FsGetTextResource("menu/select/pick/polygon",L"Polygon\tShift+F")
#define FSGUI_MENU_SELECT_PICK_VERTEX                     FsGetTextResource("menu/select/pick/vertex",L"Vertex\tShift+V")
#define FSGUI_MENU_SELECT_POLYGON                         FsGetTextResource("menu/select/polygon",L"Polygon")
#define FSGUI_MENU_SELECT_POLYGON_ALL                     FsGetTextResource("menu/select/polygon/all",L"All")
#define FSGUI_MENU_SELECT_POLYGON_EDGECONNECTED           FsGetTextResource("menu/select/polygon/edgeconnected",L"Edge-Conncted from Current Selection")
#define FSGUI_MENU_SELECT_POLYGON_FROMEDGE                FsGetTextResource("menu/select/polygon/fromedge",L"From Edge (2 vertices)")
#define FSGUI_MENU_SELECT_POLYGON_INVERT                  FsGetTextResource("menu/select/polygon/invert",L"Invert")
#define FSGUI_MENU_SELECT_POLYGON_NONTRIANGULAR           FsGetTextResource("menu/select/polygon/nontriangular",L"Non-Triangular Polygon")
#define FSGUI_MENU_SELECT_POLYGON_OFSELECTEDFACEGROUP     FsGetTextResource("menu/select/polygon/ofselectedfacegroup",L"Of Selected Face Groups")
#define FSGUI_MENU_SELECT_POLYGON_SAMECOLORFROMCURRENTSELECTION FsGetTextResource("menu/select/polygon/samecolorfromcurrentselection",L"Same Color from Current Selection")
#define FSGUI_MENU_SELECT_POLYGON_SHORTESTPATH            FsGetTextResource("menu/select/polygon/shortestpath",L"Shortest Path")
#define FSGUI_MENU_SELECT_POLYGON_TANGLED                 FsGetTextResource("menu/select/polygon/tangled",L"Tangled Polygons")
#define FSGUI_MENU_SELECT_POLYGON_UNSELECT                FsGetTextResource("menu/select/polygon/unselect",L"Unselect")
#define FSGUI_MENU_SELECT_POLYGON_USINGATLEASTONESELECTEDVERTEX FsGetTextResource("menu/select/polygon/usingatleastoneselectedvertex",L"Using at Least One of Selected Vertices")
#define FSGUI_MENU_SELECT_POLYGON_ZERONORMAL              FsGetTextResource("menu/select/polygon/zeronormal",L"Without Assigned Normal Vector")
#define FSGUI_MENU_SELECT_SHELL                           FsGetTextResource("menu/select/shell",L"Shell")
#define FSGUI_MENU_SELECT_SHELL_BYDIALOG                  FsGetTextResource("menu/select/shell/bydialog",L"By Dialog")
#define FSGUI_MENU_SELECT_SHELL_NEXTSHELL                 FsGetTextResource("menu/select/shell/nextshell",L"Next Shell\tCtrl+Tab")
#define FSGUI_MENU_SELECT_SHELL_PICKCURRENTSHELL          FsGetTextResource("menu/select/shell/pickcurrentshell",L"Pick Current Shell")
#define FSGUI_MENU_SELECT_SHELL_PREVSHELL                 FsGetTextResource("menu/select/shell/prevshell",L"Previous Shell\tCtrl+Shift+Tab")
#define FSGUI_MENU_SELECT_UNSELECT                        FsGetTextResource("menu/select/unselect",L"Unselect")
#define FSGUI_MENU_SELECT_UNSELECT_ALL                    FsGetTextResource("menu/select/unselect/all",L"Unselect All\tT")
#define FSGUI_MENU_SELECT_VERTEX                          FsGetTextResource("menu/select/vertex",L"Vertex")
#define FSGUI_MENU_SELECT_VERTEX_ALL                      FsGetTextResource("menu/select/vertex/all",L"All")
#define FSGUI_MENU_SELECT_VERTEX_BYHASHKEY                FsGetTextResource("menu/select/vertex/byhashkey",L"By Internal Hash Key (for Debugging)")
#define FSGUI_MENU_SELECT_VERTEX_BYINDEX                  FsGetTextResource("menu/select/vertex/byindex",L"By Index Number")
#define FSGUI_MENU_SELECT_VERTEX_EDGECONNECTEDBTWNSELVTHD FsGetTextResource("menu/select/vertex/edgeconnectedbtwnselvthd",L"Edge-Connected Vertices between Selected Vertices")
#define FSGUI_MENU_SELECT_VERTEX_FOLLOWBOUNDARY           FsGetTextResource("menu/select/vertex/followboundary",L"Follow Singl-Use Edge\tX")
#define FSGUI_MENU_SELECT_VERTEX_INVERT                   FsGetTextResource("menu/select/vertex/invert",L"Invert")
#define FSGUI_MENU_SELECT_VERTEX_OFSELECTEDCONSTEDGE      FsGetTextResource("menu/select/vertex/ofselectedconstedge",L"Of Selected Const Edges")
#define FSGUI_MENU_SELECT_VERTEX_OFSELECTEDPOLYGONS       FsGetTextResource("menu/select/vertex/ofselectedpolygons",L"Of Selected Polygons")
#define FSGUI_MENU_SELECT_VERTEX_ONENEIGHBORFROMSELECTION FsGetTextResource("menu/select/vertex/oneneighborfromselection",L"1 Neighbor from Selected Vertices")
#define FSGUI_MENU_SELECT_VERTEX_SINGLE_USE_EDGE_LOOP     FsGetTextResource("menu/select/vertex_single_use_edge_loop",L"Single-use edge loop from one or two selected verticex")
#define FSGUI_MENU_SELECT_VERTEX_UNSELECT                 FsGetTextResource("menu/select/vertex/unselect",L"Unselect")
#define FSGUI_MENU_SELECT_VERTEX_USEDBYTWOCONSEDGE        FsGetTextResource("menu/select/vertex/usedbytwoconsedge",L"Used by Two Const Edges")
#define FSGUI_MENU_SKETCH                                 FsGetTextResource("menu/sketch",L"Sketch Interface")
#define FSGUI_MENU_SKETCH_CREATECONSTEDGE                 FsGetTextResource("menu/sketch/createconstedge",L"Create Const-Edges by Sketch Interface")
#define FSGUI_MENU_UTILITY                                FsGetTextResource("menu/utility",L"Utility")
#define FSGUI_MENU_UTILITY_CONSTEDGE                      FsGetTextResource("menu/utility/constedge",L"Const Edge")
#define FSGUI_MENU_UTILITY_CONSTEDGE_ADDBYDHA             FsGetTextResource("menu/utility/constedge/addbydha",L"Add by Dihedral Angle")
#define FSGUI_MENU_UTILITY_CONSTEDGE_ADDFGBOUNDARY        FsGetTextResource("menu/utility/constedge/addfgboundary",L"Add Const-Edge on Face-Group Boundaries")
#define FSGUI_MENU_UTILITY_CONSTEDGE_ADDNONMANIFOLD       FsGetTextResource("menu/utility/constedge/addnonmanifold",L"Add Const-Edge along Non-Manifold Edges")
#define FSGUI_MENU_UTILITY_CONSTEDGE_CLEAR                FsGetTextResource("menu/utility/constedge/clear",L"Delete All Const Edges")
#define FSGUI_MENU_UTILITY_CONSTEDGE_CONSTRAINALL         FsGetTextResource("menu/utility/constedge/constrainall",L"Constrain All Edges")
#define FSGUI_MENU_UTILITY_CONSTEDGE_OPENCLOSELOOP        FsGetTextResource("menu/utility/constedge/opencloseloop",L"Open/Close a Loop")
#define FSGUI_MENU_UTILITY_CONSTEDGE_RECONSIDER           FsGetTextResource("menu/utility/constedge/reconsider",L"Auto Connect/Split Const Edgesdir")
#define FSGUI_MENU_UTILITY_CONSTEDGE_SETNAME              FsGetTextResource("menu/utility/constedge/setname",L"Set Const-Edge Name")
#define FSGUI_MENU_UTILITY_FACEGROUP                      FsGetTextResource("menu/utility/facegroup",L"Face Group")
#define FSGUI_MENU_UTILITY_FACEGROUP_CLEARALL             FsGetTextResource("menu/utility/facegroup/clearall",L"Delete All Face Groups")
#define FSGUI_MENU_UTILITY_FACEGROUP_EXPAND_TO_UNASSIGNED FsGetTextResource("menu/utility/facegroup/expand_to_unassigned",L"Expand Current Face Groups to Unassigned Polygons")
#define FSGUI_MENU_UTILITY_FACEGROUP_FROM_CONSTEDGE       FsGetTextResource("menu/utility/facegroup_from_constedge",L"Make Face Groups from Const Edges")
#define FSGUI_MENU_UTILITY_FACEGROUP_SETNAME              FsGetTextResource("menu/utility/facegroup/setname",L"Set Face Group Name")
#define FSGUI_MENU_UTILITY_PAINT_BASED_ON_FACEGROUP       FsGetTextResource("menu/utility/paint_based_on_facegroup",L"Paint Based on Face Groups")
#define FSGUI_MENU_UTILITY_REPAIR                         FsGetTextResource("menu/utility/repair",L"Repair")
#define FSGUI_MENU_UTILITY_REPAIR_FREESTITCH              FsGetTextResource("menu/utility/repair/freestitch",L"Free Stitching")
#define FSGUI_MENU_UTILITY_REPAIR_LOOPSTITCH              FsGetTextResource("menu/utility/repair/loopstitch",L"Loop Stitching")
#define FSGUI_MENU_UTIL_FACEGROUP_CLEARALL                FsGetTextResource("menu/util/facegroup/clearall",L"Delete All Face Groups")
#define FSGUI_MENU_VIEW                                   FsGetTextResource("menu/view",L"View")
#define FSGUI_MENU_VIEW_CROSSSECTION                      FsGetTextResource("menu/view/crosssection",L"Cross Section")
#define FSGUI_MENU_VIEW_CROSSSECTION_ENABLE               FsGetTextResource("menu/view/crosssection/enable",L"Enable")
#define FSGUI_MENU_VIEW_CROSSSECTION_INVERT               FsGetTextResource("menu/view/crosssection/invert",L"Invert")
#define FSGUI_MENU_VIEW_CROSSSECTION_MOVE                 FsGetTextResource("menu/view/crosssection/move",L"Move")
#define FSGUI_MENU_VIEW_CROSSSECTION_RESET                FsGetTextResource("menu/view/crosssection/reset",L"Enable")
#define FSGUI_MENU_VIEW_DRAWAXES                          FsGetTextResource("menu/view/drawaxes",L"Draw Axes")
#define FSGUI_MENU_VIEW_DRAWBACKFACEDIFFCOLOR             FsGetTextResource("menu/view/drawbackfacediffcolor",L"Draw Back Face in Different Color")
#define FSGUI_MENU_VIEW_DRAWBACKGROUNDGRADATION           FsGetTextResource("menu/view/drawbackgroundgradation",L"Draw Background Gradation")
#define FSGUI_MENU_VIEW_DRAWCONSTEDGE                     FsGetTextResource("menu/view/drawconstedge",L"Draw Const Edges")
#define FSGUI_MENU_VIEW_DRAWPOLYGONEDGES                  FsGetTextResource("menu/view/drawpolygonedges",L"Draw Polygon Edges")
#define FSGUI_MENU_VIEW_DRAWPOLYGONFILL                   FsGetTextResource("menu/view/drawpolygonfill",L"Draw Polygon Fill")
#define FSGUI_MENU_VIEW_DRAWSHURNKPOLYGONS                FsGetTextResource("menu/view/drawshurnkpolygons",L"Draw Shrunk Polygons")
#define FSGUI_MENU_VIEW_DRAWVERTEX                        FsGetTextResource("menu/view/drawvertex",L"Draw Vertex")
#define FSGUI_MENU_VIEW_HIGHLIGHT                         FsGetTextResource("menu/view/highlight",L"Highlight")
#define FSGUI_MENU_VIEW_HIGHLIGHT_HIGHASPECTRATIOTRIANDQUAD FsGetTextResource("menu/view/highlight/highaspectratiotriandquad",L"High Aspect-Ratio Triangles and Quadrilaterals")
#define FSGUI_MENU_VIEW_HIGHLIGHT_HIGHDHAWITHINFACE       FsGetTextResource("menu/view/highlight/highdhawithinface",L"High Dihedral Angle Within Face Group")
#define FSGUI_MENU_VIEW_HIGHLIGHT_NONMANIFOLDEDGES        FsGetTextResource("menu/view/highlight/nonmanifoldedges",L"Non-Manifold Edges")
#define FSGUI_MENU_VIEW_HIGHLIGHT_SELFINTERSECTINGPOLYGONS FsGetTextResource("menu/view/highlight/selfintersectingpolygons",L"Self-Intersecting Polygons")
#define FSGUI_MENU_VIEW_HIGHLIGHT_SHOWHIGHLIGHT           FsGetTextResource("menu/view/highlight/showhighlight",L"Show Highlighted Elements")
#define FSGUI_MENU_VIEW_LOOKAT                            FsGetTextResource("menu/view/lookat",L"Look At...")
#define FSGUI_MENU_VIEW_LOOKAT_PICKEDVERTEX               FsGetTextResource("menu/view/lookat/pickedvertex",L"Picked Vertex\tR")
#define FSGUI_MENU_VIEW_LOOKAT_POLYGON                    FsGetTextResource("menu/view/lookat/polygon",L"Polygon\tShift+R")
#define FSGUI_MENU_VIEW_LOOKAT_POLYGONSTRAIGHT            FsGetTextResource("menu/view/lookat/polygonstraight",L"Polygon Straight\tCtrl+Shift+R")
#define FSGUI_MENU_VIEW_LOOKAT_SELECTIONBB                FsGetTextResource("menu/view/lookat/selectionbb",L"Selection - Bounding-Box Center")
#define FSGUI_MENU_VIEW_LOOKAT_SELECTIONCG                FsGetTextResource("menu/view/lookat/selectioncg",L"Selection - Center of Gravity")
#define FSGUI_MENU_VIEW_REFBMP                            FsGetTextResource("menu/view/refbmp",L"Reference Bitmap")
#define FSGUI_MENU_VIEW_REFBMP_HIDEALL                    FsGetTextResource("menu/view/refbmp/hideall",L"Hide All Reference Bitmaps")
#define FSGUI_MENU_VIEW_REFBMP_LOADCONFIG                 FsGetTextResource("menu/view/refbmp/loadconfig",L"Load Reference Bitmap Configuration")
#define FSGUI_MENU_VIEW_REFBMP_OPENDIALOG                 FsGetTextResource("menu/view/refbmp/opendialog",L"Open Reference Bitmap Dialog")
#define FSGUI_MENU_VIEW_REFBMP_SAVECONFIG                 FsGetTextResource("menu/view/refbmp/saveconfig",L"Save Reference Bitmap Configuration")
#define FSGUI_MENU_VIEW_REFBMP_SHOWALL                    FsGetTextResource("menu/view/refbmp/showall",L"Show All Reference Bitmaps")
#define FSGUI_MENU_VIEW_REFRESHBUFFERS                    FsGetTextResource("menu/view/refreshbuffers",L"Refresh Vertex Buffers")
#define FSGUI_MENU_VIEW_RESETVIEWRANGE                    FsGetTextResource("menu/view/resetviewrange",L"Reset View Range")
#define FSGUI_MENU_VIEW_VIEWPORT                          FsGetTextResource("menu/view/viewport",L"View Port")
#define FSGUI_MENU_VIEW_VIEWPORT_ENABLE                   FsGetTextResource("menu/view/viewport/enable",L"Enable View Port")
#define FSGUI_MENU_VIEW_VIEWPORT_EXPAND                   FsGetTextResource("menu/view/viewport/expand",L"Expand")
#define FSGUI_MENU_VIEW_VIEWPORT_FROM_SELECTION           FsGetTextResource("menu/view/viewport_from_selection",L"View Port from Selection")
#define FSGUI_MENU_VIEW_VIEWPORT_MOVE                     FsGetTextResource("menu/view/viewport/move",L"Move View Port")
#define FSGUI_MENU_VIEW_VIEWPORT_MOVETOROTATIONCENTER     FsGetTextResource("menu/view/viewport/movetorotationcenter",L"Move to Rotation Center")
#define FSGUI_MENU_VIEW_VIEWPORT_RESET                    FsGetTextResource("menu/view/viewport/reset",L"Reset View Port")
#define FSGUI_MENU_VIEW_VIEWPORT_SHRINK                   FsGetTextResource("menu/view/viewport/shrink",L"Shrink")
#define FSGUI_MENU_VIEW_VIEWPORT_USESAMEVIEWPORTFORALL    FsGetTextResource("menu/view/viewport/usesameviewportforall",L"Use Same View Port for All Shells")
#define FSGUI_WARNING_STLWARNING                          FsGetTextResource("warning/stlwarning",L"STL is the worst possible data format.  An STL file does not retain color, \nexplicit connection, other meta data, and can store only triangles.  \nIt is the source of all sorts of problem, and STL should be gone.  Please \nsave in this format only when you need to export this data in the STL \nformat.\n\nAre you sure you want to save your model in the STL format?")
#define FSGUI_WARNING_STLWARNINGTITLE                     FsGetTextResource("warning/stlwarningtitle",L"Are you sure you want to save in the STL format?")
/* } */
#endif
